:- module_interface(prolog_meta).

:- import(prolog_types).
:- import(prolog_num).

type clause_term == goal.

:- pred clause(goal, goal).		        % StdP
:- pred call(goal).			        % StdP
:- pred once(goal).			        % StdP
:- pred top^goal.
:- pred assert(goal).
:- pred asserta(clause_term).		        % StdP
:- pred assertz(clause_term).		        % StdP
:- pred retract(goal).			        % StdP
:- pred retractall(goal).

:- type pred_indicator --> atom / nat.
:- pred current_predicate(pred_indicator).	% StdP

%:- type term == top.
:- type atom == top.
:- type atomic == top.
:- type compound_term == top.
:- type pred_ind == top.   % a predicate indicator of the form name/arity
:- pred abolish(pred_ind).                      % StdP

:- pred top =.. list(top).			% StdP
:- pred functor(term,atomic,nat).		% StdP
:- pred arg(nat,compound_term,term).		% StdP
:- pred copy_term(term,term).	          	% StdP


:- pred bagof(Term, goal, list(@Term)).	        % StdP
:- pred setof(Term, goal, list(@Term)).		% StdP
:- pred findall(Term, goal, list(@Term)).       % StdP


:- pred var(top).		                % StdP
:- pred nonvar(term).		                % StdP
:- pred ground(top).
:- pred atom(term).		                % StdP
:- pred atomic(term).		                % StdP
:- pred compound(term).		                % StdP

:- pred simple(top).

:- pred name(top,list(top)).
:- pred numbervars(top,nat,nat).

:- pred subsumes_chk(top,top).

:- end_interface(prolog_meta).